| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
Attrib::WellLog Class Reference
WellAttrib

WellLog Attribute More...

`#include <welllogattrib.h>`

Inheritance diagram for Attrib::WellLog:
[legend]

## Public Member Functions
| WellLog (Desc &)
void | prepareForComputeData () override
Public Member Functions inherited from Attrib::Provider
void | addLocalCompZIntervals (const TypeSet< Interval< int > > &)
virtual void | adjust2DLineStoredVolume ()
int | alignInputs (ObjectSet< Provider > &)
int | comparePosAndAlign (Provider *, bool, Provider *, bool, bool)
void | computeNewStartPos (BinID &)
void | computeRefStep ()
void | computeRefZ0 ()
void | doParallel (bool yn)
void | enableAllOutputs (bool yn=true)
void | enableOutput (int output, bool yn=true)
uiString | errMsg () const
virtual void | fillDataPackWithTrc (RegularSeisDataPack *) const
float | getApplicableCrlDist (bool) const
virtual void | getCompNames (BufferStringSet &) const
virtual void | getCompOutputIDs (TypeSet< int > &) const
Coord | getCoord (const BinID &) const
Coord | getCurrentCoord () const
BinID | getCurrentPosition () const
virtual const SeisTrcInfo * | getCurrentTrcInfo () const
const DataHolder * | getData (const BinID &relpos=BinID::noStepout(), int idx=0)
const DataHolder * | getDataDontCompute (const BinID &relpos) const
bool | getDataUnavailableFlag () const
const BinID & | getDesBufStepout () const
Desc & | getDesc ()
const Desc & | getDesc () const
const TrcKeyZSampling * | getDesiredVolume () const
float | getDistBetwTrcs (const Pos::GeomID &) const
BinID | getElementStepout () const
virtual Pos::GeomID | getGeomID () const
ObjectSet< Provider > & | getInputs ()
const TrcKeyZSampling * | getPossibleVolume () const
virtual bool | getPossibleVolume (int outp, TrcKeyZSampling &)
float | getRefStep () const
float | getRefZ0 () const
const BinID & | getReqBufStepout () const
virtual BinID | getStepoutStep () const
int | getTotalNrPos (bool) const
BinID | getTrcInfoBid () const
virtual void | initSteering ()
bool | is2D () const
virtual bool | isOK () const
bool | isOutputEnabled (int output) const
virtual bool | isSingleTrace () const
const TypeSet< Interval< int > > & | localCompZIntervals () const
| mOD_DisableCopy (Provider) static RefMan< Provider > create(Desc &
virtual int | moveToNextTrace (BinID startpos=BinID::udf(), bool firstcheck=false)
virtual bool | needStoredInput () const
int | nrOutputs () const
virtual void | prepPriorToBoundsCalc ()
virtual bool | prepPriorToOutputSetup ()
virtual void | prepSteeringForStepout (const BinID &)
void | resetDesiredVolume ()
void | resetMoved ()
void | resetZIntervals ()
virtual bool | setCurrentPosition (const BinID &)
void | setDataUnavailableFlag (bool yn)
virtual void | setDesBufStepout (const BinID &, bool wait=false)
void | setDesiredVolume (const TrcKeyZSampling &)
void | setExactZ (const TypeSet< float > &)
void | setExtraZ (const Interval< float > &)
virtual void | setGeomID (Pos::GeomID)
void | setNeedInterpol (bool)
void | setOutputInterestSize (bool preserve=false)
void | setPossibleVolume (const TrcKeyZSampling &)
virtual void | setRdmPaths (const TypeSet< BinID > &truepath, const TypeSet< BinID > &snappedpath)
| For directional attributes.
void | setRefStep (float step)
void | setRefZ0 (float z0)
virtual void | setReqBufStepout (const BinID &, bool wait=false)
void | setSelData (const Seis::SelData *)
void | setUseSC ()
virtual void | updateCSIfNeeded (TrcKeyZSampling &) const
void | updateCurrentInfo ()
void | updateInputReqs (int input=-1)
virtual void | updateStorageReqs (bool all=false)
virtual bool | usesTracePosition () const
Public Member Functions inherited from RefCount::Referenced
void | addObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
int | nrRefs () const
| Only for expert use.
void | ref () const
bool | refIfReffed () const
| Don't use in production, for debugging.
void | removeObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
bool | tryRef () const
| Not for normal use. May become private.
void | unRef () const
void | unRefNoDelete () const

## Static Public Member Functions
static const char * | attribName ()
static void | initClass ()
static const char * | keyStr ()
static const char * | logName ()
static const char * | upscaleType ()
Static Public Member Functions inherited from Attrib::Provider
static uiString | prepare (Desc &)
Static Public Member Functions inherited from RefCount::Referenced
static bool | isSane (const Referenced *)

## Protected Member Functions
| ~WellLog ()
bool | allowParallelComputation () const override
bool | computeData (const DataHolder &, const BinID &relpos, int t0, int nrsamples, int threadid) const override
bool | getInputData (const BinID &, int idx) override
bool | getInputOutput (int input, TypeSet< int > &res) const override
Protected Member Functions inherited from Attrib::Provider
| Provider (Desc &)
virtual | ~Provider ()
void | addParent (Provider *prov)
virtual bool | checkInpAndParsAtStart ()
void | computeDesInputCube (int inp, int out, TrcKeyZSampling &, bool usestepout=true) const
float | crlDist () const
virtual const BinID * | desStepout (int input, int output) const
virtual const Interval< float > * | desZMargin (int input, int output) const
virtual const Interval< int > * | desZSampMargin (int input, int output) const
float | dipFactor () const
virtual bool | doNotReUseDH () const
void | fillInputRangesArray (Array2DImpl< BasicInterval< int > > &, int, const BasicInterval< int > &)
virtual bool | finalizeCalculation (bool scs)
DataHolder * | getDataHolder (const BinID &relpos)
int | getDataIndex (int input) const
float | getExtraZFromSampInterval (int, int) const
float | getExtraZFromSampPos (float) const
float | getInputValue (const DataHolder &, int inputidx, int sampleidx, int z0) const
float | getInterpolInputValue (const DataHolder &, int inputidx, float sample, int z0) const
float | getInterpolInputValue (const DataHolder &, int inputidx, float zval) const
virtual SeisMSCProvider * | getMSCProvider (bool &) const
virtual BinDataDesc | getOutputFormat (int output) const
virtual bool | getZ0StoredData (float &z0) const
float | getZAtSample (int idx) const
virtual bool | getZStepStoredData (float &step) const
float | inlDist () const
bool | isNew2DLine () const
bool | isUsedMultTimes ()
float | lineDist () const
float | maxSecureDip () const
virtual int | minTaskSize () const
virtual bool | preProcCommonToAllThreads (const DataHolder &out, const BinID &relpos)
void | removeDataHolder (const BinID &relpos)
virtual const BinID * | reqStepout (int input, int output) const
virtual const Interval< float > * | reqZMargin (int input, int output) const
virtual const Interval< int > * | reqZSampMargin (int input, int output) const
void | setInput (int input, Provider *)
virtual bool | setNrThreads (int idx)
void | setOutputValue (const DataHolder &output, int outputidx, int sampleidx, int z0, float val) const
void | setUsedMultTimes ()
void | stdPrepSteering (const BinID &)
float | trcDist () const
virtual bool | useInterTrcDist () const
float | zFactor () const
bool | zIsTime () const
Protected Member Functions inherited from RefCount::Referenced
| Referenced ()
| Referenced (const Referenced &)
virtual | ~Referenced ()
Referenced & | operator= (const Referenced &)

## Static Protected Member Functions
static Provider * | createInstance (Desc &)
Static Protected Member Functions inherited from Attrib::Provider
static RefMan< Provider > | internalCreate (Desc &, RefObjectSet< Provider > &, bool &issame, uiString &)

## Protected Attributes
StepInterval< float > | arrzrg_
BufferString | logname_
Array1D< float > * | logvals_ = nullptr
int | upscaletype_
MultiID | wellid_
Protected Attributes inherited from Attrib::Provider
WeakPtrSet< Provider > | allexistingprov_
bool | alreadymoved_ = false
BinID | currentbid_ = BinID::udf()
const SeisTrcInfo * | curtrcinfo_ = nullptr
bool | dataunavailableflag_ = false
BinID | desbufferstepout_
RefMan< Desc > | desc_
TrcKeyZSampling * | desiredvolume_ = nullptr
uiString | errmsg_
TypeSet< float > | exactz_
Interval< float > | extraz_
Pos::GeomID | geomid_
RefObjectSet< Provider > | inputs_
bool | isusedmulttimes_ = false
DataHolderLineBuffer * | linebuffer_ = nullptr
TypeSet< Interval< int > > | localcomputezintervals_
bool | needinterp_ = false
TypeSet< int > | outputinterest_
bool | parallel_ = true
WeakPtrSet< Provider > | parents_
TrcKeyZSampling * | possiblevolume_ = nullptr
int | prevtrcnr_ = 0
ProviderTask * | providertask_ = nullptr
float | refstep_ = 0.f
float | refz0_ = 0.f
BinID | reqbufferstepout_
const Seis::SelData * | seldata_ = nullptr
BinID | trcinfobid_ = BinID::udf()
bool | useshortcuts_ = false

## Additional Inherited Members
Public Attributes inherited from Attrib::Provider
uiString & | errmsg

## Detailed Description

WellLog Attribute

Reads a log from 1 well and extends it laterally

    WellLog

    Outputs:
    0               Well log data

<>

## Constructor & Destructor Documentation

## ◆ WellLog()

Attrib::WellLog::WellLog | ( | Desc & |  | ) |

## ◆ ~WellLog()

Attrib::WellLog::~WellLog | ( |  | ) |
| protected

## Member Function Documentation

## ◆ allowParallelComputation()

bool Attrib::WellLog::allowParallelComputation | ( |  | ) | const
| override protected virtual

Reimplemented from Attrib::Provider.

## ◆ attribName()

static const char * Attrib::WellLog::attribName | ( |  | ) |
| inline static

## ◆ computeData()

bool Attrib::WellLog::computeData | ( | const DataHolder & | output,
|  | const BinID & | relpos,
|  | int | t0,
|  | int | nrsamples,
|  | int | threadidx ) const
| override protected virtual

The system will use the algorithm specified in this function to compute the attribute's outputs. The results will be stored as different series in the DataHolder output.

Parameters

  output |
  relpos |
  t0 |
  nrsamples |
  threadidx | thread identifier that may be handy when using multiple threads.

Implements Attrib::Provider.

## ◆ createInstance()

static Provider * Attrib::WellLog::createInstance | ( | Desc & |  | ) |
| static protected

## ◆ getInputData()

bool Attrib::WellLog::getInputData | ( | const BinID & | relpos,
|  | int | idx )
| override protected virtual

Gets all imput data, including data for which a stepout is required

Reimplemented from Attrib::Provider.

## ◆ getInputOutput()

bool Attrib::WellLog::getInputOutput | ( | int | input,
|  | TypeSet< int > & | ) const
| override protected virtual

Specifies the outputs needed for calculation among all those provided by the input data; very usefull when steering used as input data

Reimplemented from Attrib::Provider.

## ◆ initClass()

static void Attrib::WellLog::initClass | ( |  | ) |
| static

## ◆ keyStr()

static const char * Attrib::WellLog::keyStr | ( |  | ) |
| inline static

## ◆ logName()

static const char * Attrib::WellLog::logName | ( |  | ) |
| inline static

## ◆ prepareForComputeData()

void Attrib::WellLog::prepareForComputeData | ( |  | ) |
| override virtual

Everything is known now.

Reimplemented from Attrib::Provider.

## ◆ upscaleType()

static const char * Attrib::WellLog::upscaleType | ( |  | ) |
| inline static

## Member Data Documentation

## ◆ arrzrg_

StepInterval<float> Attrib::WellLog::arrzrg_
| protected

## ◆ logname_

BufferString Attrib::WellLog::logname_
| protected

## ◆ logvals_

Array1D<float>* Attrib::WellLog::logvals_ = nullptr
| protected

## ◆ upscaletype_

int Attrib::WellLog::upscaletype_
| protected

## ◆ wellid_

MultiID Attrib::WellLog::wellid_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025